#include <iostream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <array>
#include <iomanip>
#include <unordered_map>
#include <utility>
#include <unordered_set>
#include <bitset>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>
#define sz(_a) ((int)(_a).size())
#define int ll

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> par;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#ifdef MAKS
#define deb(a) #a << '\t' << a << '\t'
#else
#define deb(a) ""
#endif // MAKS



template <typename K, typename L>
std::ostream& operator<<(std::ostream& os, const pair<K, L>& p) {
#ifdef MAKS
    os << '(';
#endif // MAKS
    os << p.first << ' ' << p.second;
#ifdef MAKS
    os << ')';
#endif // MAKS
    return os;
}

template <template <class, class...> class C, typename K, typename... Args,
    typename std::enable_if<!std::is_same<K, char>::value>::type* = nullptr>
std::ostream& operator<<(std::ostream& os, const C<K, Args...>& a) {
#ifdef MAKS
    if (!sz(a)) {
        os << 'E';
    }
#endif // MAKS
    for (const auto& i : a) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}






















const int M = 998'244'353;

inline signed solve() {

    int n;
    cin >> n;
    vector<ll> f(n + 1);
    f[1] = 1;
    for (int i = 2; i <= n; ++i) {
        f[i] = (1 + 3 * f[i - 1]) % M;
    }
    vector<int> was(n);
    vector<int> now(n);
    for (int i = 0; i < n; ++i) {
        cin >> was[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> now[i];
    }

    ll ans = 0;

    auto gg = [&](int ws, int nw, int& prev_pos, int& cur_pos, int i) {
        if (abs(ws - nw) == 1) {
            ++ans;
            cur_pos = prev_pos = ws ^ nw;
        } else if (ws != nw) {
            ans += 2 * f[i] + 2;
            cur_pos = ws;
            prev_pos = nw;
        }
        ans %= M;
    };

    int lst = -2;
    int cur_pos = -1;
    int prev_pos = -1;
    for (int i = n - 1; i >= 0 && lst == -2; --i) {
        if (was[i] != now[i]) {
            lst = i - 1;
            gg(was[i], now[i], prev_pos, cur_pos, i);
        }
    }
    /*if (lst == -2) {
        cout << "?";
    }*/

    auto hhh = [&](int& pos, const vector<int>& vec, int i) {
        int tmp;
        int old_pos = pos;
        gg(pos, vec[i], tmp, pos, i);
        ans += f[i] * abs(old_pos - tmp);
        ans %= M;
    };

    for (int i = lst; i >= 0; --i) {
        hhh(cur_pos, now, i);
        hhh(prev_pos, was, i);
    }

    cout << ans << '\n';

    return 0;
}


signed main() {
#ifdef MAKS
    double start = clock();
    freopen("in.txt", "r", stdin);
#endif // MAKS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(11);
    cerr << fixed << setprecision(3);

    int t_t = 1;
    cin >> t_t;

    while (t_t--) {
        solve();
    }

#ifdef MAKS
    cerr << "\nTime: " << (clock() - start) * 1000.0 / CLOCKS_PER_SEC << "ms\n";
#endif // MAKS
    return 0;
}
