#include <iostream>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <tuple>
#include <random>
#include <chrono>

using namespace std;

#define ln "\n"
#define pb push_back
#define mp make_pair
#define ins insert
#define sz(x) (int)x.size()
#define All(x) (x).begin(), (x).end()
#define Allf(x) (x).begin() + 1, (x).end()

#define fi(a, b) for(auto i = a; i <= b; i++)
#define fj(a, b) for(auto j = a; j <= b; j++)
#define fo(a, b) for(auto o = a; o <= b; o++)
#define fw(a, b) for(auto w = a; w <= b; w++)

#define fdi(a, b) for(auto i = a; i >= b; i--)
#define fdj(a, b) for(auto j = a; j >= b; j--)
#define fdo(a, b) for(auto o = a; o >= b; o--)
#define fdw(a, b) for(auto w = a; w >= b; w--)

#define fx( A) for(auto& x: (A) )
#define fy( A) for(auto& y: (A) )
#define fz( A) for(auto& z: (A) )

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<long long> vll;
typedef vector<vi> vvi;
typedef pair<int, int> pii;

template<typename T>
ostream& operator<<(ostream& os, vector<T> v){
    fx( v) {
        os << x << ' ';
    }
    return os;
}

template<typename T>
ostream& operator<<(ostream& os, set<T> v){
    fx( v) {
        os << x << ' ';
    }
    return os;
}

template<typename T1,typename T2>
ostream& operator<<(ostream& os, pair<T1,T2> v){
    
    os << "(" << v.first << ", " << v.second << ")";
    
    return os;
}

#ifdef LOCAL
#define dbg(x) { cerr << __LINE__ << "\t" << #x << ": " <<  (x) << ln; }
#else
#define dbg(x) {}
#endif

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());


int n,m;
vvi e,er;
vector<pair<int,int> > edges;
vi u,ord;
void dfs(int v){
    if(u[v])return;
    u[v] = true;
    fz(e[v]){
        dfs(z);
    }
    ord.pb(v);
}


vector<int> comp;
int C;
void dfs2(int v){
    if(comp[v])return;
    comp[v] = C;
    fz(er[v]){
        dfs2(z);
    }
}





void solve() {
    

    vi p(n + 1);
    fi(1, n){
        p[i] = i;
    }


   
    vi ord(n + 1);
    fi(1,n){
         ord[p[i]] = i;
    }
    int cnt = 0;
    fz(edges){
        if(p[z.first] < p[z.second]){
            cnt++;
     }
    }
    if(cnt >= ( m + 1) / 2){
    fi(1,n){
        cout << ord[i] << ' ';
    }
    cout << ln;
    return;
    }


    p = vi(n + 1);
    fi(1, n){
        p[i] = n - i + 1;
    }


   
    ord = vi(n + 1);
    fi(1,n){
         ord[p[i]] = i;
    }
    cnt = 0;
    fz(edges){
        if(p[z.first] < p[z.second]){
            cnt++;
     }
    }
    if(cnt >= ( m + 1) / 2){
    fi(1,n){
        cout << ord[i] << ' ';
    }
    cout << ln;
    return;
    }
    
    
    


    cout << -1 << ln;
    


}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #endif

    int TEST;
    cin >> TEST;
    while(TEST--){
        cin >> n >> m;
       
        e = vvi(n + 1);
        er = vvi(n + 1);
        edges.clear();
        fi(1,m){
            int x,y;
            cin >> x >> y;
            e[x].pb(y);
            er[y].pb(x);
            edges.pb(mp(x,y));
        }
        solve();
    }    

    

    return 0;

}

/*ord.clear();
    u = vi(n + 1);
    fi(1,n){
        if(!u[i]){
            dfs(i);
        }
    }

    comp = vi(n + 1);
    C = 1;
    reverse(All(ord));
    u = vi(n + 1);
    fz(ord){
        if(!u[z]){
            dfs2(z);
            C++;
        }
    }






    
    
    
*/