﻿#pragma warning(disable : 4996)
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <queue>
#include <list>
#include <stack>
#include <fstream>
#include <sstream>
#include <functional>
#include <climits>

#define all(t) t.begin(), t.end()
#define ll long long
#define ull unsigned long long
#define ld long double
#define ainb(a, b) (b.find(a) != b.end())
#define vll vector<ll>
#define vec vector
#define cll(cll_i) ll cll_i; cin >> cll_i;
#define pll pair<ll, ll>
#define vpl vec<pll>
#define invll(invec_v, invec_n) vll invec_v(invec_n); for (ll &invec_i : invec_v) cin >> invec_i;
#define outvec(outvec_v) for (auto &outvec_i : outvec_v) cout << outvec_i << " "; cout << '\n';
#define sqr(x) (x) * (x)
#define FOR(FOR_I, FOR_END) for (ll FOR_I = 0; FOR_I < FOR_END; FOR_I++)
#define FE(FOR_I, ITERABLE) for (auto &FOR_I : ITERABLE)
#define FEC(FOR_I, ITERABLE) for (const auto &FOR_I : ITERABLE)
using namespace std;

void solve()
{
    cll(n);
    cll(m);


    vec<vll> g(n);
    vpl es;
    for (ll i = 0; i < m; i++)
    {
        ll u, v;
        cin >> u >> v;
        es.push_back({ u - 1, v - 1 });
        g[u - 1].push_back(v - 1);
    }

    stack<ll> dfs;
    dfs.push(0);
    vec<bool> used(n, false);
    used[0] = 1;

    vll res;

    while (!dfs.empty())
    {
        ll u = dfs.top();
        dfs.pop();
        res.push_back(u);
        for (ll v : g[u])
        {
            if (used[v]) continue;

            dfs.push(v);
            used[v] = true;
        }
    }

    map<ll, ll> mp;
    for (ll i = 0; i < n; i++)
    {
        mp[res[i]] = i;
    }

    ll k = 0;
    for (ll i = 0; i < m; i++)
    {
        if (mp[es[i].first] < mp[es[i].second])
        {
            k++;
        }
    }

    if (k < (m + 1) / 2)
    {
        reverse(all(res));
    }
    for (ll i = 0; i < n; i++)
    {
        cout << res[i] + 1 << " ";
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG

    ll t = 1;
    cin >> t;
    while (t--) solve();

    return 0;
}
