#include<bits/stdc++.h>

using namespace std;

#define int long long

int const maxn = 2e5 + 5;
int a[maxn], inf = 1e9 + 7;
int b[maxn], st[maxn];
int mod = 1e9 + 7;

int pw(int x, int y) {
    if (y == 0) return 1;
    if (y % 2 == 0) return pw(x * x % mod, y / 2);
    return x * pw(x, y - 1) % mod;
}

int check(int n, int x) {
    for (int i = 1; i <= n; i++) {
        if (a[i] < x) return 0;
    }
    int sum = 0;
    for (int i = n; i >= 1; i--) {
        if ((n - i) % 2 == 0) sum = (sum + (a[i] - x) * st[n - i]) % mod;
        else sum = (sum - (a[i] - x) * st[n - i] % mod + mod) % mod;
    }
    if (n % 2 == 0)
        sum = (mod - sum) * pw(pw(2, n) - 1, mod - 2) % mod;
    else
        sum = sum * pw(pw(2, n) + 1, mod - 2) % mod;
    int tgk = sum;
    //cout << tgk << endl;
    for (int cnt = max(0ll, tgk - 2); cnt <= tgk + 2 && cnt * 2 <= a[1] && cnt <= a[n]; cnt++) {
        for (int i = 1; i <= n; i++) b[i] = a[i] - x;
        b[1] -= 2 * cnt, b[n] -= cnt;
        int flag = 1;
        for (int j = 1; j < n; j++) {
            if (b[j] < 0) {
                flag = 0;
                break;
            }
            else b[j + 1] -= 2 * b[j];
        }
        flag &= (b[n] == 0);
        if (flag) return 1;
    }
    return 0;
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    st[0] = 1;
    for (int i = 1; i < maxn; i++) st[i] = st[i - 1] * 2 % mod;
    while (t--) {
        int n;
        cin >> n;
        for (int i = 1; i <= n; i++) cin >> a[i];
        //cout << check(n, 774);
        //exit(0);
        int ans = 0;
        for (int need = 0; need < 3; need++) {
            int lef = -1, righ = inf;
            while (righ - lef > 1) {
                int mid = (righ + lef) / 2;
                int c = 3 * mid + need;
                if (check(n, c)) lef = mid;
                else righ = mid;
            }
            ans = max(ans, lef * 3 + need);
        }
        cout << ans << '\n';
    }
    return 0;
}

