﻿#include <iostream>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

void dfs(vector<vector<ll>>& gr, vector<bool>& used, ll v, vector<ll>& t) {
    used[v] = true;
    for (auto i : gr[v]) {
        if (!used[i]) dfs(gr, used, i, t);
    }
    t.push_back(v);
}

void doTopSort(vector<vector<ll>>& gr, vector<bool>& used, vector<ll>& ans) {
    ans.clear();
    for (int i = 0; i < gr.size(); i++) {
        if (!used[i]) dfs(gr, used, i, ans);
    }
    reverse(ans.begin(), ans.end());
}

int main()
{
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vector <vector<ll>> gr(n);
        vector<pair<ll, ll>> p(m);
        for (int i = 0; i < m; i++) {
            ll x, y;
            cin >> x >> y;
            x--; y--;
            p[i] = { x, y };
            gr[x].push_back(y);
        }
        vector<ll> a;
        for (int i = 0; i < n; i++) {
            a.push_back(i + 1);
        }
        ll cnt = 0;
        bool fl = 0;
        while (cnt < 100) {
            random_shuffle(a.begin(), a.end());
            map<ll, ll>dict;
            for (int i = 0; i < a.size(); i++) {
                dict[a[i]] = i;
            }
            ll cnt = 0;
            for (int i = 0; i < m; i++) {
                if (dict[p[i].first] < dict[p[i].second]) cnt++;
            }
            if (cnt >= m / 2) {
                for (auto i : a) cout << i << " ";
                cout << endl;
                fl = 1;
                break;
            }
            else continue;
        }
        if (!fl) cout << -1 << endl;
        /*vector<bool> used(n);
        vector<ll> ans;
        doTopSort(gr, used, ans);
        map<ll, ll>dict;
        for (int i = 0; i < ans.size(); i++) {
            dict[ans[i]] = i;
        }
        ll cnt = 0;
        for (int i = 0; i < m; i++) {
            if (dict[p[i].first] < dict[p[i].second]) cnt++;
        }
        if (cnt >= m / 2) {
            for (auto i : ans) cout << ++i << " ";
            cout << endl;
        }
        else cout << -1 << endl;*/
    }
    /*ll t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vector<pair<ll, ll>> a(n), p(n);
        for (int i = 0; i < n; i++) cin >> a[i].second;
        for (int i = 0; i < n; i++) cin >> a[i].first;
        sort(a.begin(), a.end());
        bool fl = 0;
        for (int i = 0; i < n; i++) {
            p[i].first = a[i].first;
            p[i].second = a[i].first - a[i].second;
            if (p[i].second < 0) fl = 1;
        }
        sort(p.begin(), p.end());
        ll ans = -1;
        for (int i = 0; i < n - 1; i++) {
            if (p[i + 1].first == p[i].first && p[i].second != p[i + 1].second) {
                fl = 1;
                break;
            }
            else if (p[i+1].second < p[i].second) {
                fl = 1;
                break;
            }
        }
        if (fl) cout << -1 << endl;
        else cout << p[n-1].second << endl;
    }*/
    return 0;
}

