#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <set>
#include <map>
#include <stack>


using namespace std;

typedef long long ll;

void solve();

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	cin >> t;

	while (t--) {
		solve();
		cout << "\n";
	}
}


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> g(n);
	vector<int> in(n);
	int mx = 0;

	for (int i = 0; i < n; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		g[a].push_back(b);
		mx = max(mx, ++in[b]);
	}

	vector<unordered_set<int>> vByIn(mx + 1);

	for (int i = 0; i < n; ++i) {
		vByIn[in[i]].insert(i);
	}

	int k = 0;
	stack<int> ans;
	vector<int> used(n);

	for (int i = mx; i >= 0; --i) {
		while (!vByIn[i].empty()) {
			auto first = *vByIn[i].begin();
			vByIn[i].erase(first);
			k += in[first];
			used[first] = 1;

			for (auto x : g[first]) {
				if (used[x]) continue;
				vByIn[in[x]].erase(x);
				--in[x];
				vByIn[in[x]].insert(x);
			}

			ans.push(first);
		}
	}

	if (k < m / 2 + m % 2) {
		cout << -1;
		return;
	}

	while (!ans.empty()) {
		cout << ans.top() + 1 << " ";
		ans.pop();
	}

}