﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <string>
#include <set>
#include <map>
#include <queue>
#define ll long long
#define vll vector <ll>
#define f(i, n) for(int i = 0; i < n; i++)
#define pll pair <ll, ll>
#define mp(a, b) make_pair(a, b)
using namespace std;
ll sz = 10000000;
string result = "";

void dfs(ll v, vector<vll>& bohr, string& ans) {
    for (ll i = 0; i < 26; i++) {
        if (bohr[v][i] != 0) {
            ans += char('a' + i);
            dfs(bohr[v][i], bohr, ans);
            ans.pop_back();
        }
        else {
            ans += char('a' + i);
            if (ans.size() < sz) {
                sz = 1ll * ans.size();
                result = ans;
            }
            ans.pop_back();
        }
    }
}

void solve() {
    ll n, e;
    cin >> n >> e;
    vector <vll> bohr;
    bohr.push_back(vll(26));

    for (ll i = 0; i < n; i++) {
        string s;
        cin >> s;
        ll v = 0;
        ll l = s.size();
        for (ll j = 0; j < 1000; j++) {
            if (bohr[v][s[j % l] - 'a'] != 0) {
                v = bohr[v][s[j % l] - 'a'];
            }
            else {
                bohr[v][s[j % l] - 'a'] = bohr.size();
                bohr.push_back(vll(26));
                v = bohr[v][s[j % l] - 'a'];
            }
        }
    }

    ll v = 0;
    string ans = "";
    dfs(v, bohr, ans);
    cout << (sz > 1000 ? "NO" : result);
}


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
}