﻿//#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <stack>
#include <random>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <climits>
#include <tuple>


using namespace std;
using ll = long long;
using db = double;
using ldb = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vll = vector<ll>;
using vvll = vector<vector<ll>>;
using vint = vector<int>;
using vst = vector<string>;
#define all(x) x.begin(), x.end()
#define size(x) int(x.size())
#define forp(i,s,f) for(int i = s; i < f; ++i)
#define form(i,s,f) for(int i = s; i > f; --i)
#define dprint(x) for(auto now: x) cout << now << ' '

const int MOD = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int MOD3 = 998244353;
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;
const double EPS = 1e-9;
const double PI = acosl(-1.0);

void solve() {
    ll n;
    cin >> n;
    vll prev(n), now(n);
    forp(i, 0, n) cin >> now[i];
    forp(i, 0, n) cin >> prev[i];
    vector<pll> sp;
    forp(i, 0, n) {
        sp.push_back({ now[i], prev[i] });
    }
    sort(all(sp));
    vll asd;
    forp(i, 0, n) {
        asd.push_back(sp[i].second - sp[i].first);
    }
    forp(i,1,n) {
        if (asd[i] < asd[i - 1]) {
            cout << "-1\n";
            return;
        }
    }
    cout << asd[n - 1] << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(x);
    cout << fixed;
    int t;
    //t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
