#include <bits/stdc++.h>

#define F first
#define S second


using ld = long double;
using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;

using namespace std;

pair<int, int> e[200010];
vector<int> g[100010];
vector<int> order;
vector<bool> u;

int inf = 1000000;

void dfs(int v) {
    u[v] = 1;
    for (auto to: g[v]) {
        if (!u[to]) {
            dfs(to);
        }
    }
    order.push_back(v);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        int n, e;
        cin >> n >> e;
        std::vector<string> seqs(n);
        for (int i = 0; i < n; ++i) {
            cin >> seqs[i];
        }
        set<char> only;
        map<char, int> cum_pref_len;
        for (char x = 'a'; x < 'a' + e; ++x) {
            int pref = 0;
            for (auto& seq : seqs) {
                for (int i = 0; i < seq.size(); ++i) {
                    if (seq[i] == x) {
                        pref += 1;
                    } else {
                        break;
                    }
                }
                if (pref == seq.size()) {
                    only.emplace(x);
                }
                cum_pref_len[x] += pref;
            }
        }
        if (only.size() == e) {
            cout << "NO\n";
        } else {
            pair<int, char> len = make_pair(inf, 'F');
            for (char x = 'a'; x < 'a' + e; ++x) {
                if (only.find(x) != only.end()) {
                    continue;
                }
                len = min(len, make_pair(cum_pref_len[x], x));
            }
            string s;
            s.resize(len.first + 1);
            fill(begin(s), end(s), len.second);
            cout << s;
        }
    }
}
