﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <unordered_map>

#define ll long long;
#define all(x) (x).begin(), (x).end()

using namespace std;
vector<pair<int, int>> ans;
vector<char> used;
vector<vector<int>> edge;
vector<vector<int>> redge;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	int t; cin >> t;
	while (t--) {
		int n, m; cin >> n >> m;
		edge.resize(n);
		redge.resize(n);
		used.assign(n, 0);
		ans.resize(n);
		for (int i = 0; i < n; i++) {
			ans[i].second = i;
		}
		for (int i = 0; i < m; i++) {
			int u, v; cin >> u >> v;
			u--; v--;
			edge[u].push_back(v);
			redge[v].push_back(u);
			ans[u].first += 1;
		}

		queue<int> q;
		int mx_i = 0;
		for (int i = 0; i < n; i++) {
			if (ans[i].first > ans[mx_i].first) {
				mx_i = i;
			}
		}

		//cout << "!!!!" << mx_i << ' ' << ans[mx_i].first << '\n';

		for (int i = 0; i < n; i++) {
			if (ans[mx_i].first == ans[i].first) {
				q.push(i);
				used[i] = 1;
			}
		}

		vector<int> retval;
		while (!q.empty()) {
			int v = q.front();
			q.pop();
			retval.push_back(v);
			for (auto u : edge[v]) {
				if (!used[u]) {
					q.push(u);
					used[u] = 1;
				}
			}
		}

		for (auto& i : retval) {
			cout << i + 1 << ' ';
		}
		cout << '\n';
		//sort(all(ans));
		//reverse(all(ans));
		//for (int i = 0; i < n; i++) {
			//cout << ans[i].second + 1 << " ";
		//}
		//cout << "\n";
	}
}
