﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>

#define ll long long
#define vll vector<long long>
#define REP(i, s, n) for (size_t i = s; i < n; ++i)
#define VIN(v) for (auto &i : v) { cin >> i; }
using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	ll t;
	cin >> t;
	for (int _ = 0; _ < t; _++) {
		ll min_i = -1;
		ll min_e = 1000000001;
		ll sum_a = 0;
		ll n;
		cin >> n;
		vector<ll> a(n);

		for (int i = 0; i < n; i++) {
			cin >> a[i];
			if (a[i] < min_e) {
				min_e = a[i];
				min_i = i;
			}

			sum_a += a[i];
		}

		sum_a -= min_e * n;
		
		if (sum_a % 3 && !(n % 3)) {
			cout << 0 << endl;
			continue;
		}

		int adj = 0;
		while (sum_a % 3) {
			sum_a += n;
			adj++;
		}

		int d4 = (a[(min_i - 2 + n) % n] - min_e + adj) * 10 + a[(min_i - 1 + n) % n] - min_e + adj;
		if (d4 % 4 == 0) {
			cout << min_e - adj << endl;
			continue;
		}

		cout << 0 << endl;
	}
}