﻿#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <deque>
#include <stack>
#include <list>
#include <bitset>
#include <string>

#define num long long

using namespace std;



void solution() {
	num n, m;
	cin >> n >> m;

	num k = 0;

	for (num i = 0; i < m; i++) {
		num f, t;
		cin >> f >> t;

		if (f > t) {
			k += 1;
		}
	}
	
	if (k > m / 2 + m % 2) {
		for (num i = 0; i < n; i++) {
			cout << i + 1 << " ";
		}
	}
	else {
		for (num i = n - 1; i > -1; i--) {
			cout << i + 1 << " ";
		}
	}
	cout << "\n";
}



num search(num x, vector<num> nums) {
	num left = 0; num right = nums.size();
	num mid = (left + right) / 2;
	while (left + 1 < right) {
		if (nums[mid] <= x) {
			left = mid;
		}
		else {
			right = mid;
		}
	}
	return left;

}
 
int main() {
	ios_base::sync_with_stdio(false);
	num n = 1;
	cin >> n;
	while (n--) {
		solution();
	}

	return 0;
}
