def execute():
    n = int(input())
    data = sorted(zip(map(int, input().split()), map(int, input().split())), key=lambda val: (val[1], -val[0]))

    ans = 0
    last_diff = 0
    left_max = 0
    for i, (x1, x2) in enumerate(data):
        if x1 > x2 or x1 < left_max or last_diff > (x2 - x1):
            print(-1)
            return
        left_max = max(left_max, x1)
        last_diff = x2 - x1
        ans = max(ans, last_diff)

    print(ans)


def main():
    t = int(input())
    for _ in range(t):
        execute()


main()
