#include <bits/stdc++.h>
using namespace std;

#ifndef DBG
//#define NDEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif

#define cn const
#define cauto cn auto
#define endl '\n'
#define FOR(i, from, to) for (int i = (from); i <= (to); ++i)
#define FORN(i, n) FOR(i, 0, (n) - 1)
#define mp make_pair
#define pb push_back
#define F first
#define S second
#define X F
#define Y S
#define CONT(c) begin(c), end(c)
#define ARR(a, sz) (a), ((a) + (sz))

using ll = long long;
using ull = unsigned long long;
using uint = unsigned;

// find_by_order, order_of_key
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
template<typename Key>
using ordered_set = __gnu_pbds::tree<Key, __gnu_pbds::null_type, less<Key>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
template<typename Key, typename Value>
using ordered_map = __gnu_pbds::tree<Key, Value, less<Key>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<typename T>
 T sqr(const T& x)
{
    return x * x;
}

template<typename T>
bool rMin(T& v, const T& rval)
{
    if (rval < v) {
        v = rval;
        return true;
    }
}

template<typename T>
bool rMax(T& v, const T& rval)
{
    if (v < rval) {
        v = rval;
        return true;
    }
}

template<int Modulo>
struct MOD {
    static cn int M = Modulo;
    uint x;
    MOD(int val = 0) : x(val) { assert(0 <= val && val < M); }

    MOD& operator +=(MOD r) {
        x += r.x;
        if (x >= M)
            x -= M;
        return *this;
    }
    friend MOD operator+(MOD l, MOD r) { return l += r; }

    MOD& operator *=(MOD r) {
        x = (ll(x) * r.x) % M;
        return *this;
    }
    friend MOD operator*(MOD l, MOD r){ return l *= r; }

    MOD& operator -=(MOD r) {
        x -= r.x;
        if (x >= M)
            x += M;
        return *this;
    }
    friend operator-(MOD l, MOD r) { return l -= r; }

    friend MOD operator -(MOD a){
        if (a.x)
            return M - a.x;
        return 0;
    }

    friend ostream& operator <<(ostream& cout, MOD x){ return cout << x.x; }
    friend bool operator ==(MOD l, MOD r){ return l.x == r.x; }
    friend bool operator <(MOD l, MOD r){ return l.x < r.x; }
};

namespace std {
template<int Modulo>
struct hash<MOD<Modulo>> {
    size_t operator()(MOD<Modulo> a) const noexcept { return a.x; }
};
}

template<int M>
MOD<M> binpow(MOD<M> a, ll p)
{
    MOD<M> res = 1;
    while (p) {
        if (p & 1)
            res *= a;
        a *= a;
        p >>= 1;
    }
    return res;
}

// Code start here

using Mod = MOD<998'244'353>;

void precalc()
{
}

int k, suffix_cnt, big_cnt, mask_cnt;
int k_value;

bool good(int M)
{
    FORN(m, mask_cnt)
        if (M >> m & 1) {
            auto pref = m >> 1;
            auto suf = m & (suffix_cnt - 1);
            if (pref == k_value || suf == k_value)
                return true;
        }
    return false;
}

vector<Mod> calc(int len)
{
    assert(len > k);
    vector<vector<Mod>> from(suffix_cnt, vector<Mod>(mask_cnt, 0));
    auto to = from;
    FORN(i, suffix_cnt)
        from[i][0] = 1;
    FOR(l, k + 1, len) {
        for (auto& v : to)
            fill(CONT(v), Mod(0));
        FORN(suf, suffix_cnt)
            FORN(nxt, 2) {
                auto new_mask = (suf << 1) | nxt;
                auto new_suf = new_mask & (suffix_cnt - 1);
                FORN(masks, mask_cnt)
                    //to.at(new_suf).at(masks | (1 << new_mask)) += from.at(suf).at(masks);
                    to[new_suf][masks | (1 << new_mask)] += from[suf][masks];
            }
        swap(from, to);
    }
    vector<Mod> res(mask_cnt, Mod(0));
    for (auto& v : from)
        FORN(masks, mask_cnt)
            res[masks] += v[masks];
    FORN(masks, mask_cnt)
        if (!good(masks))
            res[masks] = 0;
    return res;
}

vector<Mod> sum_over_subset(cn vector<Mod>& val)
{
    vector<Mod> sum(mask_cnt, Mod(0));
    FORN(m, mask_cnt) {
        for (int sub = m; ; sub = (sub - 1) & m) {
            sum[m] += val[sub];
            if (sub == 0)
                break;
        }
    }
    return sum;
}

void solve()
{
    int n, m;
    cin >> n >> m >> k;
    suffix_cnt = 1 << k;
    big_cnt = 1 << (k + 1);
    mask_cnt = 1 << big_cnt;
    FORN(i, k) {
        char c;
        cin >> c;
        k_value = k_value * 2 + (c - '0');
    }
    if (n < m)
        swap(n, m);
    if (n == k) {
        cout << 1 << endl;
        return;
    }
    auto dp_n = calc(n);
    if (m == k) {
        cout << accumulate(CONT(dp_n), Mod(0)) << endl;
        return;
    }
    auto s_m = sum_over_subset(calc(m));
    Mod ans = 0;
    FORN(m, mask_cnt) {
        cauto inv = (mask_cnt - 1) ^ m;
        ans += dp_n[m] * s_m[inv];
    }
    cout << ans << endl;
}

signed main()
{
#ifdef MY
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif // MY
    precalc();
    /*
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i)
    */
        solve();
}
