﻿#pragma warning(disable : 4996)
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <queue>
#include <list>
#include <stack>
#include <fstream>
#include <sstream>
#include <functional>
#include <climits>

#define all(t) t.begin(), t.end()
#define ll long long
#define ull unsigned long long
#define ld long double
#define ainb(a, b) (b.find(a) != b.end())
#define vll vector<ll>
#define vec vector
#define cll(cll_i) ll cll_i; cin >> cll_i;
#define pll pair<ll, ll>
#define vpl vec<pll>
#define invll(invec_v, invec_n) vll invec_v(invec_n); for (ll &invec_i : invec_v) cin >> invec_i;
#define outvec(outvec_v) for (auto &outvec_i : outvec_v) cout << outvec_i << " "; cout << '\n';
#define sqr(x) (x) * (x)
#define FOR(FOR_I, FOR_END) for (ll FOR_I = 0; FOR_I < FOR_END; FOR_I++)
#define FE(FOR_I, ITERABLE) for (auto &FOR_I : ITERABLE)
#define FEC(FOR_I, ITERABLE) for (const auto &FOR_I : ITERABLE)
using namespace std;

void solve()
{
    cll(n);
    cll(e);

    vec<string> bs(n);
    FE(b, bs) cin >> b;

    vec<bool> sp(e, false);
    for (ll i = 0; i < n; i++)
    {
        char c = bs[i][0];
        bool ok = true;
        for (ll j = 1; j < bs[i].size(); j++)
        {
            if (bs[i][j] != bs[i][j - 1])
            {
                ok = false;
                break;
            }
        }
        if (ok)
        {
            sp[c - 'a'] = true;
        }
    }
    bool ok = true;
    for (ll i = 0; i < sp.size(); i++)
    {
        ok = ok && sp[i];
    }
    if (ok)
    {
        cout << "NO\n";
        return;
    }

    vll cs(e);
    for (ll i = 0; i < e; i++)
    {
        for (ll j = 0; j < n; j++)
        {
            for (ll k = 0; k < bs[j].size(); k++)
            {
                if (bs[j][k] - 'a' == i)
                {
                    cs[i]++;
                }
                else
                {
                    break;
                }
            }
        }
    }

    ll best_letter = 'a';
    ll mnm = 1e9;
    for (ll i = 0; i < e; i++)
    {
        if (cs[i] < mnm)
        {
            mnm = cs[i];
            best_letter = 'a' + i;
        }
    }

    for (ll i = 0; i < mnm + 1; i++)
    {
        cout << (char)(best_letter);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG

    ll t = 1;
    //cin >> t;
    while (t--) solve();

    return 0;
}
