﻿
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <deque>
#include <stack>
#include <string>
#include <cstdint>

#define en '\n'
#define isz(x) int(x.size())
#define ins insert
#define pb push_back
#define str string
#define vec vector
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define fin(x) for (auto &it : x) cin >> it
#define fout(x) for (auto &it : x) cout << it << ' '; cout << en

using namespace std;
using ll = long long;
using ld = long double;
using i64 = int64_t;
using i32 = int32_t;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using V = vector<T>;
using vi = V<int>;
using vl = V<ll>;
using vpii = V<pii>;
using vpll = V<pll>;
using vld = V<ld>;
using vb = V<bool>;
using vc = V<char>;
using vs = V<str>;
using ull = unsigned long long;

template<typename T>
using pqsmalleststart = priority_queue<T, vector<T>, greater<T>>;

template<typename T>
using pqmaximumstart = priority_queue<T, vector<T>, less<T>>;

vector<vector<int>> g;

vi path;
vb used;


void dfs(int v) {
    path.pb(v);
    used[v] = 1;
    for (int next : g[v]) {
        if (!used[next]) dfs(next);
    }
}

void solve() {
    int n, m; cin >> n >> m;
    g = vector<vector<int>>(n + 1);
    used = vb(n + 1);
    path.clear();
    vector<pii> e(m);

    for (size_t i = 0; i < m; i++)
    {
        int a, b; cin >> a >> b;
        g[a].pb(b);
    }
    
    for (size_t i = 1; i <= n; i++)
    {
        if (!used[i]) dfs(i);
    }
    vi rank(n + 1);
    int id = 0;
    for (int v : path) {
        rank[v] = id++;
    }
    {
        int c = 0;
        for (auto [a, b] : e) {
            if (rank[a] < rank[b]) c++;
        }
        if (c >= (m + 1) / 2) {
            fout(path);
            return;
        }
    }
    reverse(all(path));
    {
        int c = 0;
        for (auto [a, b] : e) {
            if (rank[a] < rank[b]) c++;
        }
        if (c >= (m + 1) / 2) {
            fout(path);
            return;
        }
    }
    cout << -1 << en;
}

void multiSolve() {
    int t_; cin >> t_; while (t_--) {
        solve();
    }
}

void brute() {

}

void trash() {

}

int main()
{
    ios_base::sync_with_stdio(false);  cin.tie(0); cout.tie(0);
    //cout.setf(ios::fixed); cout.precision(20);

    //trash();
    //brute();
    //solve();
    multiSolve();
}