﻿//#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <algorithm>
#include <numeric>
#include <stack>
#include <random>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <climits>


using namespace std;
using ll = long long;
using db = double;
using ldb = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vll = vector<ll>;
using vvll = vector<vector<ll>>;
using vint = vector<int>;
using vst = vector<string>;
#define all(x) x.begin(), x.end()
#define size(x) int(x.size())
#define forp(i,s,f) for(int i = s; i < f; ++i)
#define form(i,s,f) for(int i = s; i > f; --i)
#define dprint(x) for(auto now: x) cout << x << ' '

const int MOD = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int MOD3 = 998244353;
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<pair<int, string>> a(n);
    for (size_t i = 0; i < n; i++)
    {
        cin >> a[i].second;
    }
    char letter = 'a', best_letter = 'a';
    int iter = 0;
    ll maxc = LLONG_MAX;
    while (letter - 'a' < k) {
        for (size_t i = 0; i < n; i++)
        {
            a[i].first = 0;
        }
        iter = 1;
        while (true)
        {
            bool f = 0;
            if (iter > 10000) {
                break;
            }
            for (size_t i = 0; i < n; i++)
            {
                if (a[i].second[a[i].first] == letter) {
                    iter++;
                    a[i].first++;
                    a[i].first %= (int) size(a[i].second);
                    f = 1;
                    break;
                }
            }
            if (!f) {
                if (maxc > iter) {
                    maxc = iter;
                    best_letter = letter;
                }
                break;
            }
        }
        letter++;
    }
    if (maxc == LLONG_MAX) {
        cout << "NO";
    }
    else {
        for (size_t i = 0; i < maxc; i++)
        {
            cout << best_letter;
        }
    }
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //cout << setprecision(x);
    cout << fixed;
    int t;
    t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
