#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        int n, m;
        cin >> n >> m;
        vector< vector<int> > gr(n, vector<int>(0));
        vector<pair<int,int> > edges;
        vector<int> cnt(n), col(n);
        for (int i = 0; i < m; i++) {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            gr[a].push_back(b);
            edges.push_back(pair<int,int>{a, b});
            cnt[a]++;
        }
        set<pair<int,int> > st;
        bool flag = false;
        vector<int> res;
        while (!flag) {
            int mx = 0;
            for (int i = 0; i < n; i++) {
                if (!col[i]) mx = max(mx, cnt[i]);
            }
            for (int i = 0; i < n; i++) {
                if (cnt[i] == mx && !col[i]) {
                    st.insert(pair<int,int>{-cnt[i], i});
                }
            }
            while (!st.empty()) {
                pair<int,int> pp = *st.begin();
                res.push_back(pp.second);
                col[pp.second] = 1;
                st.erase(st.begin());
                for (int ver: gr[pp.second]) {
                    if (!col[ver]) {
                        st.insert(pair<int,int> {-cnt[ver], ver});
                    }
                }
            }
            flag = true;
            for (int i = 0; i < n; i++) {
                if (!col[i]) flag = false;
            }
        }
        vector<int> ind(n);
        for(int i = 0; i < n; i++) {
            ind[res[i]] = i;
        }
        int cnt1 = 0, cnt2 = 0;
        for (pair<int,int> edge: edges) {
            int a = edge.first, b = edge.second;
            if (ind[a] < ind[b]) cnt1++;
            else cnt2++;
        }
        if (cnt2 > cnt1) cout << -1 << '\n';
        else {
            for (int x: res) cout << x+1 << ' ';
            cout << '\n';
        }
    }
}
