#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_set>

using namespace std;

vector<unordered_set<int>> g;

bool comp(int a, int b) {
    if (g[a].size() > g[b].size() && g[a].find(b) == g[a].end() || g[a].find(b) != g[a].end()) {
        if (g[b].find(a) != g[b].end()) {
            return a < b;
        }
        return true;
    }
    return false;
}

bool comp1(int a, int b){
    return (g[a].find(b) != g[a].end() && g[b].find(a) == g[b].end())
        || g[a].find(b) != g[a].end() && g[b].find(a) != g[b].end() && g[a].size() > g[b].size()
        || g[a].find(b) == g[a].end() && g[b].find(a) == g[b].end() && g[a].size() > g[b].size();
}

bool comp2(int a, int b){
    return g[a].size() > g[b].size()
            || g[a].size() == g[b].size() && g[a].find(b) != g[a].end() && g[b].find(a) == g[b].end();
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int ktc;
    cin >> ktc;
    for (int i = 0; i < ktc; ++i) {
        int n, m;
        cin >> n >> m;
        g = vector<unordered_set<int>>(n);
        vector<pair<int, int>> e;
        for (int j = 0; j < m; ++j) {
            int a,b;
            cin >> a >> b;
            a--;b--;
            g[a].insert(b);
            e.push_back(make_pair(a, b));
        }
        vector<int> map(n);
        vector<int> v(n);
        for (int j = 0; j < n; ++j) {
            v[j] = j;
        }
        sort(v.begin(), v.end(), comp2);

        for (int j = 0; j < n; ++j) {
            map[v[j]] = j;
        }

        int cpr = 0;
        for (auto j: e) {
            if (map[j.first] < map[j.second])
                cpr++;
        }

        if (cpr >= (m + m%2)/2) {
            for (int j = 0; j < n; ++j) {
                cout << v[j] + 1 << " ";
            }
        } else {
            cout << -1;
        }
        cout << endl;
    }
    return 0;
}
/*
2
3 3
1 2
2 3
3 1
5 6
4 2
2 1
4 3
1 4
3 2
3 5
 */