﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Threading;
using System.Diagnostics;
using System.Numerics;
using System.IO;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;
using System.Globalization;
using System.Drawing;

namespace icpc
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            List<DateTime> t = new List<DateTime>(20);
            for (int i = 0; i < n; i++)
            {
                t.Add(DateTime.Parse(Console.ReadLine()));
            }
            t.Sort();
            if (Check(t, n))
            {
                Console.WriteLine(0);
                return;
            }
            for (var i = DateTime.Parse("7:00"); i <= DateTime.Parse("9:00"); i = i.AddMinutes(1))
            {
                int ind = t.BinarySearch(i);
                if (ind >= 0)
                    continue;
                t.Insert(~ind, i);
                if (Check(t, n))
                {
                    Console.WriteLine(1);
                    return;
                }
                t.RemoveAt(~ind);
            }
            for (var i = DateTime.Parse("7:00"); i <= DateTime.Parse("9:00"); i = i.AddMinutes(1))
            {
                int ind = t.BinarySearch(i);
                if (ind >= 0)
                    continue;
                t.Insert(~ind, i);
                for (var j = DateTime.Parse("7:00"); j <= DateTime.Parse("9:00"); j = j.AddMinutes(1))
                {
                    int ind2 = t.BinarySearch(j);
                    if (ind2 >= 0)
                        continue;
                    t.Insert(~ind2, j);
                    if (Check(t, n))
                    {
                        Console.WriteLine(2);
                        return;
                    }
                    t.RemoveAt(~ind2);
                }
                t.RemoveAt(~ind);
            }
        }

        static bool Check(List<DateTime> t, int n)
        {
            for (int i = 2; i < n; i++)
            {
                TimeSpan dt = t[i] - t[i - 2];
                if (dt <= TimeSpan.FromMinutes(10))
                {
                    return true;
                }
            }
            return false;
        }
    }
}
