﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Threading;
using System.Diagnostics;
using System.Numerics;
using System.IO;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;
using System.Globalization;
using System.Drawing;

namespace icpc
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] input = Console.ReadLine().Split();
            int n = int.Parse(input[0]),
                e = int.Parse(input[1]);
            Dictionary<char, int> letterCounters = new Dictionary<char, int>();
            for (char c = 'a'; c < ('a' + e); c++)
            {
                letterCounters.Add(c, 0);
            }
            for (int i = 0; i < n; i++)
            {
                char letter = Console.ReadLine()[0];
                letterCounters[letter]++;
            }
            string result = "";
            for (int i = 0; i < e; i++)
            {
                char best = letterCounters.FirstOrDefault(x => x.Value <= i).Key;
                if (best != '\0')
                {
                    result += best;
                    Console.WriteLine(result);
                    return;
                }
                else
                {
                    result += 'a';
                }
            }
            Console.WriteLine("NO");
        }
    }
}
