﻿// EProblem.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <math.h>
using namespace std;

class Circle
{
public:
	int x;
	int y;
	int r;

	Circle(int x, int y, int r)
	{
		this->x = x;
		this->y = y;
		this->r = r;
	}

};

void solve();

int main()
{
	int t;
	cin >> t;
	do
	{
		solve();
	} while (--t);
	return 0;
}

void solve()
{
	int n, X, Y, R, sum_of_r, last_c, counter = 0;
	double dist;
	vector<Circle> circles;
	cin >> n;

	for (int i = 0; i < n; ++i)
	{
		cin >> X >> Y >> R;
		circles.push_back(Circle(X, Y, R));
		last_c = circles.size() - 1;
		for (int j = 0; j < last_c; ++j)
		{
			sum_of_r = circles[j].r + circles[last_c].r;
			dist = sqrt(pow((circles[j].x - circles[last_c].x), 2) + pow((circles[j].y - circles[last_c].y), 2));
			//cout << "sum_of_r: " << sum_of_r << endl;
			//cout << "dist: " << dist << endl;
			if (sum_of_r == dist) ++counter;
		}
	}
	cout << counter << endl;
}