﻿#include <iostream>
#include <set>
#include <queue>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <string>
#include <vector>
#include <iomanip>
#include <map>

using namespace std;

void dfs(vector<vector<int>>& a, int start, vector<int>& used, vector<int>& news) {

	if (used[start] == 0) {
		used[start] = 1;
		for (int i = 0; i < a[start].size(); i++) {
			if (used[a[start][i]] != 1) {
				dfs(a, a[start][i], used, news);
				news.push_back(a[start][i] + 1);
			}
		}
	}
}

int main()
{
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector < vector <int> > a(n);
		set < vector <int> > s;
		map <int, int> in, out;
		for (int i = 0; i < m; ++i) {
			int x, y;
			cin >> x >> y;
			a[x - 1].push_back(y - 1);
			in[y - 1]++;
			out[x - 1]++;
		}
		for (int i = 0; i < n; ++i) {
			s.insert({ in[i], out[i], i });
		}
		int start = (*s.begin())[2];
		int start_firstf = (*s.begin())[0];
		auto it = s.begin()++;
		while ((*it)[0] == start_firstf ) {
			start = (*it)[2];
			it++;
			if (it == s.end())
				break;
		}
		vector<int> used(n, 0);
		vector<int> news;
		news.push_back(start + 1);
		dfs(a, start, used, news);
		for (int i = 0; i < n; i++)
			cout << news[i] << ' ';
		cout << '\n';
	}
}