﻿#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <deque>
#include <stack>
#include <list>
#include <bitset>

#define num long long

using namespace std;

void solution() {
	num l, h;
	cin >> l >> h;


	

	num theeLevel = 1 + (l - 3) % 2;
	num twoLevel = l % 2;

	num ans = (min(twoLevel, theeLevel) * (h / 2 + h % 2)) + (max(twoLevel, theeLevel) * (h / 2));
	
	cout << ans << "\n";
}

num search(num x, vector<num> nums) {
	num left = 0; num right = nums.size();
	num mid = (left + right) / 2;
	while (left + 1 < right) {
		if (nums[mid] <= x) {
			left = mid;
		}
		else {
			right = mid;
		}
	}
	return left;

}
 
int main() {
	ios_base::sync_with_stdio(false);
	num n = 1;
	while (n--) {
		solution();
	}

	return 0;
}
