#include <iostream>
#include <vector>
using namespace std;
#define int long long
vector<int> g[100000 + 10];
vector<bool> used(100000 + 10);
vector<int> ans;
int deep[1000001];
int right_ = 0;
int wrong = 0;
void dfs(int v) {
    used[v] = true;
    deep[v]++;
    for (int i = 0; i < g[v].size(); i++) {
        if (used[g[v][i]] == true) {
            if (deep[g[v][i]] > deep[v]) wrong++;
            else {
                right_++;
            }
            continue;
        } else {
            right_++;
            dfs(g[v][i]);
        }
    }
    ans.push_back(v + 1);
}

signed main() {
    int n, m, t;
    cin >> t;
    while(t--) {
        cin >> n >> m;
        int st, to;
        ans.clear();
        right_ = 0;
        wrong = 0;
        for (int i = 0; i < n + 5; i++) {
            used[i] = false;
            g[i].clear();
            deep[i] = 0;
        }
        for (int i = 0; i < m; i++) {
            cin >> st >> to;
            st--, to--;
            g[st].push_back(to);
        }
        for(int i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i);
            }
        }
        if (wrong < right_) {
            for (int i = n - 1; i >= 0; i--) {
                std::cout << ans[i] << ' ';
            }
            std::cout << '\n';
            continue;
        } else {
            if (wrong >= (m + 1) / 2) {
                for (int i = 0; i < n; i++) {
                    std::cout << ans[i] << ' ';
                }
                std::cout << '\n';
                continue;
            }
        }
        cout << -1 << '\n';

    }
    return 0;
}